From: Takashi Iwai <tiwai@suse.de>
Subject: drm/msm: Remove use of vmap notifier

Revert the commit e1e9db2ca79575b8d6b4b5891194bb29c630c42d.

Signed-off-by: Takashi Iwai <tiwai@suse.de>

---
 drivers/gpu/drm/msm/msm_drv.h          |    2 -
 drivers/gpu/drm/msm/msm_gem.c          |   25 ++++----------------
 drivers/gpu/drm/msm/msm_gem.h          |   10 --------
 drivers/gpu/drm/msm/msm_gem_shrinker.c |   40 ---------------------------------
 4 files changed, 5 insertions(+), 72 deletions(-)

--- a/drivers/gpu/drm/msm/msm_drv.h
+++ b/drivers/gpu/drm/msm/msm_drv.h
@@ -153,7 +153,6 @@ struct msm_drm_private {
 		struct drm_mm mm;
 	} vram;
 
-	struct notifier_block vmap_notifier;
 	struct shrinker shrinker;
 
 	struct msm_vblank_ctrl vblank_ctrl;
@@ -213,7 +212,6 @@ void msm_gem_put_vaddr_locked(struct drm
 void msm_gem_put_vaddr(struct drm_gem_object *obj);
 int msm_gem_madvise(struct drm_gem_object *obj, unsigned madv);
 void msm_gem_purge(struct drm_gem_object *obj);
-void msm_gem_vunmap(struct drm_gem_object *obj);
 int msm_gem_sync_object(struct drm_gem_object *obj,
 		struct msm_fence_context *fctx, bool exclusive);
 void msm_gem_move_to_active(struct drm_gem_object *obj,
--- a/drivers/gpu/drm/msm/msm_gem_shrinker.c
+++ b/drivers/gpu/drm/msm/msm_gem_shrinker.c
@@ -100,42 +100,6 @@ msm_gem_shrinker_scan(struct shrinker *s
 	return freed;
 }
 
-static int
-msm_gem_shrinker_vmap(struct notifier_block *nb, unsigned long event, void *ptr)
-{
-	struct msm_drm_private *priv =
-		container_of(nb, struct msm_drm_private, vmap_notifier);
-	struct drm_device *dev = priv->dev;
-	struct msm_gem_object *msm_obj;
-	unsigned unmapped = 0;
-	bool unlock;
-
-	if (!msm_gem_shrinker_lock(dev, &unlock))
-		return NOTIFY_DONE;
-
-	list_for_each_entry(msm_obj, &priv->inactive_list, mm_list) {
-		if (is_vunmapable(msm_obj)) {
-			msm_gem_vunmap(&msm_obj->base);
-			/* since we don't know any better, lets bail after a few
-			 * and if necessary the shrinker will be invoked again.
-			 * Seems better than unmapping *everything*
-			 */
-			if (++unmapped >= 15)
-				break;
-		}
-	}
-
-	if (unlock)
-		mutex_unlock(&dev->struct_mutex);
-
-	*(unsigned long *)ptr += unmapped;
-
-	if (unmapped > 0)
-		pr_info_ratelimited("Purging %u vmaps\n", unmapped);
-
-	return NOTIFY_DONE;
-}
-
 /**
  * msm_gem_shrinker_init - Initialize msm shrinker
  * @dev_priv: msm device
@@ -149,9 +113,6 @@ void msm_gem_shrinker_init(struct drm_de
 	priv->shrinker.scan_objects = msm_gem_shrinker_scan;
 	priv->shrinker.seeks = DEFAULT_SEEKS;
 	WARN_ON(register_shrinker(&priv->shrinker));
-
-	priv->vmap_notifier.notifier_call = msm_gem_shrinker_vmap;
-	WARN_ON(register_vmap_purge_notifier(&priv->vmap_notifier));
 }
 
 /**
@@ -165,7 +126,6 @@ void msm_gem_shrinker_cleanup(struct drm
 	struct msm_drm_private *priv = dev->dev_private;
 
 	if (priv->shrinker.nr_deferred) {
-		WARN_ON(unregister_vmap_purge_notifier(&priv->vmap_notifier));
 		unregister_shrinker(&priv->shrinker);
 	}
 }
--- a/drivers/gpu/drm/msm/msm_gem.c
+++ b/drivers/gpu/drm/msm/msm_gem.c
@@ -430,7 +430,6 @@ void *msm_gem_get_vaddr_locked(struct dr
 		if (msm_obj->vaddr == NULL)
 			return ERR_PTR(-ENOMEM);
 	}
-	msm_obj->vmap_count++;
 	return msm_obj->vaddr;
 }
 
@@ -445,17 +444,13 @@ void *msm_gem_get_vaddr(struct drm_gem_o
 
 void msm_gem_put_vaddr_locked(struct drm_gem_object *obj)
 {
-	struct msm_gem_object *msm_obj = to_msm_bo(obj);
 	WARN_ON(!mutex_is_locked(&obj->dev->struct_mutex));
-	WARN_ON(msm_obj->vmap_count < 1);
-	msm_obj->vmap_count--;
+	/* no-op for now */
 }
 
 void msm_gem_put_vaddr(struct drm_gem_object *obj)
 {
-	mutex_lock(&obj->dev->struct_mutex);
-	msm_gem_put_vaddr_locked(obj);
-	mutex_unlock(&obj->dev->struct_mutex);
+	/* no-op for now */
 }
 
 /* Update madvise status, returns true if not purged, else
@@ -484,7 +479,8 @@ void msm_gem_purge(struct drm_gem_object
 
 	put_iova(obj);
 
-	msm_gem_vunmap(obj);
+	vunmap(msm_obj->vaddr);
+	msm_obj->vaddr = NULL;
 
 	put_pages(obj);
 
@@ -504,17 +500,6 @@ void msm_gem_purge(struct drm_gem_object
 			0, (loff_t)-1);
 }
 
-void msm_gem_vunmap(struct drm_gem_object *obj)
-{
-	struct msm_gem_object *msm_obj = to_msm_bo(obj);
-
-	if (!msm_obj->vaddr || WARN_ON(!is_vunmapable(msm_obj)))
-		return;
-
-	vunmap(msm_obj->vaddr);
-	msm_obj->vaddr = NULL;
-}
-
 /* must be called before _move_to_active().. */
 int msm_gem_sync_object(struct drm_gem_object *obj,
 		struct msm_fence_context *fctx, bool exclusive)
@@ -716,7 +701,7 @@ void msm_gem_free_object(struct drm_gem_
 
 		drm_prime_gem_destroy(obj, msm_obj->sgt);
 	} else {
-		msm_gem_vunmap(obj);
+		vunmap(msm_obj->vaddr);
 		put_pages(obj);
 	}
 
--- a/drivers/gpu/drm/msm/msm_gem.h
+++ b/drivers/gpu/drm/msm/msm_gem.h
@@ -34,11 +34,6 @@ struct msm_gem_object {
 	 */
 	uint8_t madv;
 
-	/**
-	 * count of active vmap'ing
-	 */
-	uint8_t vmap_count;
-
 	/* And object is either:
 	 *  inactive - on priv->inactive_list
 	 *  active   - on one one of the gpu's active_list..  well, at
@@ -88,11 +83,6 @@ static inline bool is_purgeable(struct m
 			!msm_obj->base.dma_buf && !msm_obj->base.import_attach;
 }
 
-static inline bool is_vunmapable(struct msm_gem_object *msm_obj)
-{
-	return (msm_obj->vmap_count == 0) && msm_obj->vaddr;
-}
-
 /* Created per submit-ioctl, to track bo's and cmdstream bufs, etc,
  * associated with the cmdstream submission for synchronization (and
  * make it easier to unwind when things go wrong, etc).  This only